"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Scope = /** @class */ (function () {
    function Scope(value) {
        if (typeof value !== 'undefined')
            this.value = value;
    }
    Object.defineProperty(Scope.prototype, "value", {
        get: function () {
            return this.$value;
        },
        set: function (value) {
            if (this.onChange)
                this.onChange(value);
            this.$value = value;
        },
        enumerable: true,
        configurable: true
    });
    Scope.prototype.methodResult = function (value) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (this.onChange)
            this.onChange.apply(this, [value].concat(args));
        this.$value = value;
    };
    /**
     * Wraps methods & captures their return values
     */
    Scope.prototype.handleMethods = function (methods) {
        var _this = this;
        var wrappedMethods = {};
        Object.keys(methods).forEach(function (key) {
            var method = methods[key];
            wrappedMethods[key] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var result = method(_this.value).apply(void 0, args);
                _this.methodResult(result, key);
                return result;
            };
        });
        return wrappedMethods;
    };
    return Scope;
}());
exports.default = Scope;
